
//
//
// Project       : Vorpal-Mail
//
// Source        : mime.cc
//
// Creator       : Blane Bramble                    Date          : 14th November 2000
// Amended       : Blane Bramble                    Date          : 14th March 2001
//
// License       : Copyright Virtua-Web 2000-2001, licensed under GNU General Public License (GPL) v2
//
// Description   :
//
// Implementation of MIME parser. Will provide the capability to break down a MIME
// message into it's component parts, add any necessary disclaimer text, and pass
// the components to a virus scanner (or other external program).
//

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include "mime.h"

//
// MIME_SECTION class.
//

MIME_SECTION::MIME_SECTION(char *dir)
{
fd = -1;
next = prev = NULL;

mimetype = "";
mimesubtype = "";

filename = dir;
fd = mkstemp(filename.get());

}

MIME_SECTION::~MIME_SECTION()
{
if (fd != -1)
	close(fd);
}

void MIME_SECTION::add(char *text)
{
write(fd, text, strlen(text));
}

//
// MIME_HANDLER class
//

MIME_HANDLER::MIME_HANDLER()
{
char *ptr;

first = current = NULL;
section.set("");

if ((ptr = getenv("TEMP")) == NULL && (ptr = getenv("TMP")) == NULL)
	ptr = "/var/tmp"; 

dir.set(ptr); dir.add("/vmXXXXXX");
}

MIME_HANDLER::~MIME_HANDLER()
{
}

void MIME_HANDLER::add(char *text)
{
if (first == NULL)
	{
	first = new MIME_SECTION(dir.get());
	current = first;
	}
if (*text == '-' && *(text + 1) == '-')
current->add(text);
}

