
//
//
// Project       : Vorpal-Mail
//
// Source        : mime.h
//
// Creator       : Blane Bramble                    Date          : 1st November 2000
// Amended       : Blane Bramble                    Date          : 14th March 2001
//
// License       : Copyright Virtua-Web 2000-2001, licensed under GNU General Public License (GPL) v2
//
// Definitions for MIME interpreting class. This will parse an email into it's relevant sections.
//

#include <limits.h>
#include "string.h"

#ifndef __MIME_SECTION__
#define __MIME_SECTION__

class MIME_SECTION {
	private:
		int fd;
		STRING filename;
		STRING mimetype, mimesubtype;
		MIME_SECTION *prev, *next;
	public:
		MIME_SECTION(char *);
		~MIME_SECTION();
		void add(char *);
	};

class MIME_HANDLER {
	private:
		STRING dir;
		MIME_SECTION *first;
		MIME_SECTION *current;
		STRING section;
	public:
		MIME_HANDLER();
		~MIME_HANDLER();
		void add(char *);
	};

#endif
