
//
//
// Project       : Vorpal-Mail
//
// Source        : queue.h
//
// Version       : 1.0
//
// Creator       : Blane Bramble                    Date          : 22nd February 2001
// Amended       : Blane Bramble                    Date          : 27th March 2001
//
// License       : Copyright Virtua-Web 2000-2001, licensed under GNU General Public License (GPL) v2
//
// Description   :
//
// Definitions for Queue class to manage a message queue and handle priorities
// etc.
//
// Changelog     :
//

#ifndef __QUEUE__
#define __QUEUE__

#include <sys/time.h>

#include "string.h"
#include "tlist.h"

class QUEUE {
	private:
		STRING id;
		STRING from, result;
		TLIST<STRING> to;
		TLIST<STRING> delivered;
		time_t qtime, ltime;
		long size;
		int bouncecount;
	public:
		QUEUE(void);
		QUEUE(char *);
		~QUEUE();
		void load(char *);
		char *get(void) { return id.get(); };

		long getsize(void) { return size; };
		time_t getqtime(void) { return qtime; };
		time_t getltime(void) { return ltime; };
		char *getfrom(void) { return from.get(); };
		char *getresult(void) { return result.get(); };
		TLIST<STRING> *getto(void) { return &to; };
		TLIST<STRING> *getdelivered(void) { return &delivered; };
		int getbouncecount(void) { return bouncecount; };

		int operator<(const QUEUE &) const;
		int operator>(const QUEUE &) const;
		int operator==(const QUEUE &) const;

		long priority(void) const;
	};
#endif

