
//
//
// Project       : Vorpal-Mail
//
// Source        : smtp-client.h
//
// Version       : 1.0
//
// Creator       : Blane Bramble                    Date          : 16th March 2001
// Amended       : Blane Bramble                    Date          : 27th March 2001
//
// License       : Copyright Virtua-Web 2000-2001, licensed under GNU General Public License (GPL) v2
//
// Description   :
//
// Derived SMTPCLIENT class (from SMTP main class). Provides the necessary code
// to create an SMTP client (sending) session.
//
// Changelog     :
//

#ifndef __SMTPCLIENT__
#define __SMTPCLIENT__

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <syslog.h>
#include <errno.h>
#include <fcntl.h>

#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/wait.h>


#include "mail.h"
#include "array.h"
#include "smtp.h"
#include "virtual.h"

class SMTPCLIENT : public SMTP_SESSION {
	private:
		STRING_ARRAY pending;
		void process_client(char *);
		void initialise(void);
		void cleanup(char *);
	public:
		SMTPCLIENT(void);
		SMTPCLIENT(int, struct sockaddr_in *);
		~SMTPCLIENT();
		
		void sendquit(void);
		void sendreset(void);
		void process(char *);
		void clientstatus(SMTP_STATUS);
		void clientstatus(SMTP_STATUS, char *);
		char *getresponse(void) { return last_response.get(); };
		int openfiles(char *);
		void pulse(void);
	};

#endif
