
//
//
// Project       : Vorpal-Mail
//
// Source        : smtp-server.h
//
// Version       : 1.0
//
// Creator       : Blane Bramble                    Date          : 19th March 2001
// Amended       : Blane Bramble                    Date          : 19th March 2001
//
// License       : Copyright Virtua-Web 2000-2001, licensed under GNU General Public License (GPL) v2
//
// Description   :
//
// Derived SMTPCLIENT class (from SMTP main class). Provides the necessary code
// to create an SMTP client (sending) session.
//
// Changelog     :
//

#ifndef __SMTPSERVER__
#define __SMTPSERVER__

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <syslog.h>
#include <errno.h>
#include <fcntl.h>

#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/wait.h>


#include "mail.h"
#include "array.h"
#include "smtp.h"
#include "virtual.h"

class SMTPSERVER : public SMTP_SESSION {
	private:
		void process_server(char *);
		void initialise(void);
		int checkthisrelay(char *, char *);
		int checkthislist(char *, TLIST<STRING> *);
		void cleanup(char *);
		void virushdr(char *, char *);
		void virusmsg(char *);
		int scanvirus(char *);
		void process_data(char *);
		void check_header();
		void errormail(char *);
		void localdeliver(void);
		int dolocaldeliver(char *, char *, VIRTUAL_DOMAIN *);
		void doremotedeliver(char *);
		void remotedeliver(void);
		void deliver(void);
		void awaymail(char *, char *, char *, char *, char *);

		int relayok;
		int bounce, bouncing;

	public:
		void sendbounce(char *);
		SMTPSERVER(void);
		SMTPSERVER(int, struct sockaddr_in *);
		~SMTPSERVER();

		void reset(void);
		void process(char *);
		void serverstatus(int);
		void serverstatus(int, char *);
		int checkrelay(char *);
		int openfiles(char *);
		void pulse(void);
	};

#endif
