
//
//
// Project       : Vorpal-Mail
//
// Source        : string.cc
//
// Version       : 1.0
//
// Creator       : Blane Bramble                    Date          : 23rd January 2001
// Amended       : Blane Bramble                    Date          : 15th March 2001
//
// License       : Copyright Virtua-Web 2000-2001, licensed under GNU General Public License (GPL) v2
//
// Description   :
//
// Definitions for string class.
//
// Changelog     :
//

#include <ctype.h>

#include "string.h"

STRING::STRING()
{
string = 0;
size = 0;
}


STRING::STRING(STRING *src)
{
char *p,*ptr;
size = src->size;
ptr = string = new char[size + 1];
p = src->string;
while(*p != 0)
	*ptr++ = *p++;
*ptr = 0;
}

STRING::STRING(char *ptr)
{
char *p = ptr;
size = 0;
while(*p++ != 0)
	size++;
p = string = new char[size+1];
while(*ptr != 0)
	*p++ = *ptr++;
*p = 0;
}

STRING::~STRING()
{
if (string != 0)
	delete[] string;
}

int STRING::comparecase(char *ptr)
{
char *p = string;
if (p == 0 || ptr == 0)
	return -1;
while(toupper(*p) == toupper(*ptr))
	{
	if (*p == 0)
		return 0;
	p++;
	ptr++;
	}
return *p - *ptr;
}

int STRING::compare(char *ptr)
{
char *p = string;
if (p == 0 || ptr == 0)
	return -1;
while(*p == *ptr)
	{
	if (*p == 0)
		return 0;
	p++;
	ptr++;
	}
return *p - *ptr;
}

void STRING::add(char *ptr)
{
char *old, *p, *from;

if (ptr == 0)
	return;

p = ptr;
while(*p++ != 0)
	size++;

from = old = string;
string = new char[size + 1];
p = string;
while(*from != 0)
	*p++ = *from++;
while(*ptr != 0)
	*p++ = *ptr++;
*p = 0;
delete[] old;
}

void STRING::set(char *ptr)
{
char *p;
if (string != 0)
	delete[] string;
if (ptr == 0)
	{
	string = 0;
	return;
	}
p = ptr;
size = 0;
while(*p++ != 0)
	size++;
p = string = new char[size + 1];
while(*ptr != 0)
	*p++ = *ptr++;
*p = 0;
}

void STRING::operator=(STRING &source)
{
if (this == &source)
	return;
set(source.get());
}

void STRING::operator=(char *s)
{
set(s);
}

void STRING::print(ostream *os)
{
*os << string;
}

ostream &operator<<(ostream &os, STRING &s)
{
s.print(&os);
return os;
}

